package org.infinispan.server.core;
/**
 * Common abstract decoder for Memcached and Hot Rod protocols.
 * <p>
 * @author Galder Zamarre&#x00f1;o
 * @since 4.1
 */
public abstract class AbstractProtocolDecoder<K extends java.lang.Object, V extends java.lang.Object> extends io.netty.handler.codec.ReplayingDecoder<org.infinispan.server.core.DecoderState> implements io.netty.channel.ChannelOutboundHandler, org.infinispan.server.core.ServerConstants, org.infinispan.server.core.logging.Log {
  static private  int SecondsInAMonth () { throw new RuntimeException(); }
  static private  java.util.concurrent.TimeUnit DefaultTimeUnit () { throw new RuntimeException(); }
  // not preceding
  public   AbstractProtocolDecoder (boolean secure, org.infinispan.server.core.transport.NettyTransport transport) { throw new RuntimeException(); }
  private  boolean isTrace () { throw new RuntimeException(); }
  protected  org.infinispan.server.core.RequestHeader header () { throw new RuntimeException(); }
  protected  org.infinispan.server.core.RequestParameters params () { throw new RuntimeException(); }
  protected  K key () { throw new RuntimeException(); }
  protected  byte[] rawValue () { throw new RuntimeException(); }
  protected  org.infinispan.AdvancedCache<K, V> cache () { throw new RuntimeException(); }
  protected  org.infinispan.configuration.cache.Configuration cacheConfiguration () { throw new RuntimeException(); }
  protected  long defaultLifespanTime () { throw new RuntimeException(); }
  protected  long defaultMaxIdleTime () { throw new RuntimeException(); }
  public  javax.security.auth.Subject subject () { throw new RuntimeException(); }
  public  void decode (io.netty.channel.ChannelHandlerContext ctx, io.netty.buffer.ByteBuf in, java.util.List<java.lang.Object> out) { throw new RuntimeException(); }
  private  void decodeDispatch (io.netty.channel.ChannelHandlerContext ctx, io.netty.buffer.ByteBuf in, java.util.List<java.lang.Object> out) { throw new RuntimeException(); }
  private  void secureDecodeDispatch (io.netty.channel.ChannelHandlerContext ctx, io.netty.buffer.ByteBuf in, java.util.List<java.lang.Object> out) { throw new RuntimeException(); }
  private  java.lang.Object decodeHeader (io.netty.channel.ChannelHandlerContext ctx, io.netty.buffer.ByteBuf buffer, org.infinispan.server.core.DecoderState state, java.util.List<java.lang.Object> out) { throw new RuntimeException(); }
  private  java.lang.Object decodeKey (io.netty.channel.ChannelHandlerContext ctx, io.netty.buffer.ByteBuf buffer, org.infinispan.server.core.DecoderState state) { throw new RuntimeException(); }
  public  java.lang.Object handleModification (io.netty.channel.Channel ch, io.netty.buffer.ByteBuf buf) { throw new RuntimeException(); }
  private  java.lang.Object decodeParameters (io.netty.channel.ChannelHandlerContext ctx, io.netty.buffer.ByteBuf buffer, org.infinispan.server.core.DecoderState state) { throw new RuntimeException(); }
  private  java.lang.Object decodeValue (io.netty.channel.ChannelHandlerContext ctx, io.netty.buffer.ByteBuf buffer, org.infinispan.server.core.DecoderState state) { throw new RuntimeException(); }
  protected  java.lang.Object writeResponse (io.netty.channel.Channel ch, java.lang.Object response) { throw new RuntimeException(); }
  private  java.lang.Object resetParams () { throw new RuntimeException(); }
  private  java.lang.Object put () { throw new RuntimeException(); }
  protected  org.infinispan.metadata.Metadata buildMetadata () { throw new RuntimeException(); }
  public  int actualReadableBytes () { throw new RuntimeException(); }
  private  java.lang.Object putIfAbsent () { throw new RuntimeException(); }
  private  java.lang.Object replace () { throw new RuntimeException(); }
  private  java.lang.Object replaceIfUnmodified () { throw new RuntimeException(); }
  private  java.lang.Object remove () { throw new RuntimeException(); }
  protected  java.lang.Object get (io.netty.buffer.ByteBuf buffer) { throw new RuntimeException(); }
  public  void exceptionCaught (io.netty.channel.ChannelHandlerContext ctx, java.lang.Throwable cause) { throw new RuntimeException(); }
  public  void channelActive (io.netty.channel.ChannelHandlerContext ctx) { throw new RuntimeException(); }
  public  java.lang.Object checkpointTo (org.infinispan.server.core.DecoderState state) { throw new RuntimeException(); }
  protected abstract  org.infinispan.server.core.RequestHeader createHeader () ;
  protected abstract  scala.Option<java.lang.Object> readHeader (io.netty.buffer.ByteBuf b, org.infinispan.server.core.RequestHeader header) ;
  protected abstract  org.infinispan.Cache<K, V> getCache () ;
  protected abstract  org.infinispan.configuration.cache.Configuration getCacheConfiguration () ;
  protected abstract  org.infinispan.factories.ComponentRegistry getCacheRegistry () ;
  /**
   * Returns the key read along with a boolean indicating whether the
   * end of the operation was found or not. This allows client to
   * differentiate between extra parameters or pipelined sequence of
   * operations.
   */
  protected abstract  scala.Tuple2<K, java.lang.Object> readKey (io.netty.buffer.ByteBuf b) ;
  protected abstract  boolean readParameters (io.netty.channel.Channel ch, io.netty.buffer.ByteBuf b) ;
  protected abstract  void readValue (io.netty.buffer.ByteBuf b) ;
  protected abstract  V createValue () ;
  protected abstract  java.lang.Object createSuccessResponse (V prev) ;
  protected abstract  java.lang.Object createNotExecutedResponse (V prev) ;
  protected abstract  java.lang.Object createNotExistResponse () ;
  protected abstract  java.lang.Object createGetResponse (K k, org.infinispan.container.entries.CacheEntry entry) ;
  protected abstract  java.lang.Object createMultiGetResponse (scala.collection.immutable.Map<K, org.infinispan.container.entries.CacheEntry> pairs) ;
  protected abstract  java.lang.Object createErrorResponse (java.lang.Throwable t) ;
  protected abstract  java.lang.Object createStatsResponse () ;
  protected abstract  java.lang.Object customDecodeHeader (io.netty.channel.ChannelHandlerContext ctx, io.netty.buffer.ByteBuf buffer) ;
  protected abstract  java.lang.Object customDecodeKey (io.netty.channel.ChannelHandlerContext ctx, io.netty.buffer.ByteBuf buffer) ;
  protected abstract  java.lang.Object customDecodeValue (io.netty.channel.ChannelHandlerContext ctx, io.netty.buffer.ByteBuf buffer) ;
  protected abstract  scala.Tuple2<java.lang.Exception, java.lang.Object> createServerException (java.lang.Exception e, io.netty.buffer.ByteBuf b) ;
  protected  org.infinispan.container.versioning.EntryVersion generateVersion (org.infinispan.Cache<K, V> cache) { throw new RuntimeException(); }
  /**
   * Transforms lifespan pass as seconds into milliseconds
   * following this rule:
   * <p>
   * If lifespan is bigger than number of seconds in 30 days,
   * then it is considered unix time. After converting it to
   * milliseconds, we substract the current time in and the
   * result is returned.
   * <p>
   * Otherwise it's just considered number of seconds from
   * now and it's returned in milliseconds unit.
   */
  protected  long toMillis (int lifespan) { throw new RuntimeException(); }
  public  void bind (io.netty.channel.ChannelHandlerContext ctx, java.net.SocketAddress localAddress, io.netty.channel.ChannelPromise promise) { throw new RuntimeException(); }
  public  void connect (io.netty.channel.ChannelHandlerContext ctx, java.net.SocketAddress remoteAddress, java.net.SocketAddress localAddress, io.netty.channel.ChannelPromise promise) { throw new RuntimeException(); }
  public  void disconnect (io.netty.channel.ChannelHandlerContext ctx, io.netty.channel.ChannelPromise promise) { throw new RuntimeException(); }
  public  void close (io.netty.channel.ChannelHandlerContext ctx, io.netty.channel.ChannelPromise promise) { throw new RuntimeException(); }
  public  void deregister (io.netty.channel.ChannelHandlerContext ctx, io.netty.channel.ChannelPromise promise) { throw new RuntimeException(); }
  public  void read (io.netty.channel.ChannelHandlerContext ctx) { throw new RuntimeException(); }
  public  void write (io.netty.channel.ChannelHandlerContext ctx, Object msg, io.netty.channel.ChannelPromise promise) { throw new RuntimeException(); }
  public  void flush (io.netty.channel.ChannelHandlerContext ctx) { throw new RuntimeException(); }
  public  void channelRead (io.netty.channel.ChannelHandlerContext ctx, Object msg) { throw new RuntimeException(); }
}
