package org.infinispan.server.core;
/**
 * Represents the value part of a key/value pair stored in a protocol cache.
 * With each value, a version is stored which allows for conditional operations
 * to be executed remotely in a efficient way.  For more detailed info on
 * conditional operations, check <a href="http://community.jboss.org/docs/DOC-15604">this document</a>.
 * <p>
 * The class can be marshalled either via its externalizer or via the JVM
 * serialization.  The reason for supporting both methods is to enable
 * third-party libraries to be able to marshall/unmarshall them using standard
 * JVM serialization rules.  The Infinispan marshalling layer will always
 * chose the most performant one, aka the externalizer method.
 * <p>
 * @author Galder Zamarre&#x00f1;o
 * @since 4.1
 * @deprecated
 */
public  class CacheValue {
  static public  class Externalizer extends org.infinispan.commons.marshall.AbstractExternalizer<org.infinispan.server.core.CacheValue> {
    public   Externalizer () { throw new RuntimeException(); }
    public  void writeObject (java.io.ObjectOutput output, org.infinispan.server.core.CacheValue cacheValue) { throw new RuntimeException(); }
    public  org.infinispan.server.core.CacheValue readObject (java.io.ObjectInput input) { throw new RuntimeException(); }
    public  java.util.Set<java.lang.Class<? extends org.infinispan.server.core.CacheValue>> getTypeClasses () { throw new RuntimeException(); }
  }
  public  byte[] data () { throw new RuntimeException(); }
  public  long version () { throw new RuntimeException(); }
  // not preceding
  public   CacheValue (byte[] data, long version) { throw new RuntimeException(); }
  public  java.lang.String toString () { throw new RuntimeException(); }
  public  boolean equals (Object obj) { throw new RuntimeException(); }
  public  int hashCode () { throw new RuntimeException(); }
}
