package org.infinispan.server.core;
/**
 * Represents a protocol compliant server.
 * <p>
 * @author Galder Zamarre&#x00f1;o
 * @since 4.1
 */
public  interface ProtocolServer {
  /**
   * Starts the server backed by the given cache manager and with the corresponding configuration.
   */
  public abstract  void start (org.infinispan.server.core.ProtocolServer.SuitableConfiguration configuration, org.infinispan.manager.EmbeddedCacheManager cacheManager) ;
  /**
   *  Stops the server
   */
  public abstract  void stop () ;
  /**
   * Gets the encoder for this protocol server. The encoder is responsible for writing back common header responses
   * back to client. This method can return null if the server has no encoder. You can find an example of the server
   * that has no encoder in the Memcached server.
   */
  public abstract  io.netty.channel.ChannelOutboundHandler getEncoder () ;
  /**
   * Gets the decoder for this protocol server. The decoder is responsible for reading client requests.
   * This method cannot return null.
   */
  public abstract  io.netty.channel.ChannelInboundHandler getDecoder () ;
  /**
   * Returns the configuration used to start this server
   */
  public abstract  org.infinispan.server.core.ProtocolServer.SuitableConfiguration getConfiguration () ;
  /**
   * Returns a pipeline factory
   */
  public abstract  io.netty.channel.ChannelInitializer<io.netty.channel.Channel> getInitializer () ;
}
